#ifndef __glxext_inc_
#define __glxext_inc_

#ifndef __glxext_inc__
#typedef  XID int
#endif

/*
** License Applicability. Except to the extent portions of this file are
** made subject to an alternative license as permitted in the SGI Free
** Software License B, Version 1.1 (the "License"), the contents of this
** file are subject only to the provisions of the License. You may not use
** this file except in compliance with the License. You may obtain a copy
** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
** 
** http://oss.sgi.com/projects/FreeB
** 
** Note that, as provided in the License, the Software is distributed on an
** "AS IS" basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
** 
** Original Code. The Original Code is: OpenGL Sample Implementation,
** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
** Inc. The Original Code is Copyright (c) 1991-2004 Silicon Graphics, Inc.
** Copyright in any portions created by third parties is as indicated
** elsewhere herein. All Rights Reserved.
** 
** Additional Notice Provisions: This software was created using the
** OpenGL(R) version 1.2.1 Sample Implementation published by SGI, but has
** not been independently verified as being compliant with the OpenGL(R)
** version 1.2.1 Specification.
*/

#ifndef __windows_inc__
#include "windows.inc"
#endif


#ifndef APIENTRYP
//#define APIENTRYP APIENTRY *
#endif
#ifndef GLAPI
//#define GLAPI extern
#endif

/*************************************************************/

/* Header file version number, required by OpenGL ABI for Linux */
/* glxext.h last updated 2005/04/28 */
/* Current version at http://oss.sgi.com/projects/ogl-sample/registry/ */
#define GLX_GLXEXT_VERSION 11

#ifndef GLX_VERSION_1_3
#define GLX_WINDOW_BIT                     0x00000001
#define GLX_PIXMAP_BIT                     0x00000002
#define GLX_PBUFFER_BIT                    0x00000004
#define GLX_RGBA_BIT                       0x00000001
#define GLX_COLOR_INDEX_BIT                0x00000002
#define GLX_PBUFFER_CLOBBER_MASK           0x08000000
#define GLX_FRONT_LEFT_BUFFER_BIT          0x00000001
#define GLX_FRONT_RIGHT_BUFFER_BIT         0x00000002
#define GLX_BACK_LEFT_BUFFER_BIT           0x00000004
#define GLX_BACK_RIGHT_BUFFER_BIT          0x00000008
#define GLX_AUX_BUFFERS_BIT                0x00000010
#define GLX_DEPTH_BUFFER_BIT               0x00000020
#define GLX_STENCIL_BUFFER_BIT             0x00000040
#define GLX_ACCUM_BUFFER_BIT               0x00000080
#define GLX_CONFIG_CAVEAT                  0x20
#define GLX_X_VISUAL_TYPE                  0x22
#define GLX_TRANSPARENT_TYPE               0x23
#define GLX_TRANSPARENT_INDEX_VALUE        0x24
#define GLX_TRANSPARENT_RED_VALUE          0x25
#define GLX_TRANSPARENT_GREEN_VALUE        0x26
#define GLX_TRANSPARENT_BLUE_VALUE         0x27
#define GLX_TRANSPARENT_ALPHA_VALUE        0x28
#define GLX_DONT_CARE                      0xFFFFFFFF
#define GLX_NONE                           0x8000
#define GLX_SLOW_CONFIG                    0x8001
#define GLX_TRUE_COLOR                     0x8002
#define GLX_DIRECT_COLOR                   0x8003
#define GLX_PSEUDO_COLOR                   0x8004
#define GLX_STATIC_COLOR                   0x8005
#define GLX_GRAY_SCALE                     0x8006
#define GLX_STATIC_GRAY                    0x8007
#define GLX_TRANSPARENT_RGB                0x8008
#define GLX_TRANSPARENT_INDEX              0x8009
#define GLX_VISUAL_ID                      0x800B
#define GLX_SCREEN                         0x800C
#define GLX_NON_CONFORMANT_CONFIG          0x800D
#define GLX_DRAWABLE_TYPE                  0x8010
#define GLX_RENDER_TYPE                    0x8011
#define GLX_X_RENDERABLE                   0x8012
#define GLX_FBCONFIG_ID                    0x8013
#define GLX_RGBA_TYPE                      0x8014
#define GLX_COLOR_INDEX_TYPE               0x8015
#define GLX_MAX_PBUFFER_WIDTH              0x8016
#define GLX_MAX_PBUFFER_HEIGHT             0x8017
#define GLX_MAX_PBUFFER_PIXELS             0x8018
#define GLX_PRESERVED_CONTENTS             0x801B
#define GLX_LARGEST_PBUFFER                0x801C
#define GLX_WIDTH                          0x801D
#define GLX_HEIGHT                         0x801E
#define GLX_EVENT_MASK                     0x801F
#define GLX_DAMAGED                        0x8020
#define GLX_SAVED                          0x8021
#define GLX_WINDOW                         0x8022
#define GLX_PBUFFER                        0x8023
#define GLX_PBUFFER_HEIGHT                 0x8040
#define GLX_PBUFFER_WIDTH                  0x8041
#endif

#ifndef GLX_VERSION_1_4
#define GLX_SAMPLE_BUFFERS                 100000
#define GLX_SAMPLES                        100001
#endif

#ifndef GLX_ARB_get_proc_address
#endif

#ifndef GLX_ARB_multisample
#define GLX_SAMPLE_BUFFERS_ARB             100000
#define GLX_SAMPLES_ARB                    100001
#endif

#ifndef GLX_ARB_fbconfig_float
#define GLX_RGBA_FLOAT_TYPE_ARB            0x20B9
#define GLX_RGBA_FLOAT_BIT_ARB             0x00000004
#endif

#ifndef GLX_SGIS_multisample
#define GLX_SAMPLE_BUFFERS_SGIS            100000
#define GLX_SAMPLES_SGIS                   100001
#endif

#ifndef GLX_EXT_visual_info
#define GLX_X_VISUAL_TYPE_EXT              0x22
#define GLX_TRANSPARENT_TYPE_EXT           0x23
#define GLX_TRANSPARENT_INDEX_VALUE_EXT    0x24
#define GLX_TRANSPARENT_RED_VALUE_EXT      0x25
#define GLX_TRANSPARENT_GREEN_VALUE_EXT    0x26
#define GLX_TRANSPARENT_BLUE_VALUE_EXT     0x27
#define GLX_TRANSPARENT_ALPHA_VALUE_EXT    0x28
#define GLX_NONE_EXT                       0x8000
#define GLX_TRUE_COLOR_EXT                 0x8002
#define GLX_DIRECT_COLOR_EXT               0x8003
#define GLX_PSEUDO_COLOR_EXT               0x8004
#define GLX_STATIC_COLOR_EXT               0x8005
#define GLX_GRAY_SCALE_EXT                 0x8006
#define GLX_STATIC_GRAY_EXT                0x8007
#define GLX_TRANSPARENT_RGB_EXT            0x8008
#define GLX_TRANSPARENT_INDEX_EXT          0x8009
#endif

#ifndef GLX_SGI_swap_control
#endif

#ifndef GLX_SGI_video_sync
#endif

#ifndef GLX_SGI_make_current_read
#endif

#ifndef GLX_SGIX_video_source
#endif

#ifndef GLX_EXT_visual_rating
#define GLX_VISUAL_CAVEAT_EXT              0x20
#define GLX_SLOW_VISUAL_EXT                0x8001
#define GLX_NON_CONFORMANT_VISUAL_EXT      0x800D
/* reuse GLX_NONE_EXT */
#endif

#ifndef GLX_EXT_import_context
#define GLX_SHARE_CONTEXT_EXT              0x800A
#define GLX_VISUAL_ID_EXT                  0x800B
#define GLX_SCREEN_EXT                     0x800C
#endif

#ifndef GLX_SGIX_fbconfig
#define GLX_WINDOW_BIT_SGIX                0x00000001
#define GLX_PIXMAP_BIT_SGIX                0x00000002
#define GLX_RGBA_BIT_SGIX                  0x00000001
#define GLX_COLOR_INDEX_BIT_SGIX           0x00000002
#define GLX_DRAWABLE_TYPE_SGIX             0x8010
#define GLX_RENDER_TYPE_SGIX               0x8011
#define GLX_X_RENDERABLE_SGIX              0x8012
#define GLX_FBCONFIG_ID_SGIX               0x8013
#define GLX_RGBA_TYPE_SGIX                 0x8014
#define GLX_COLOR_INDEX_TYPE_SGIX          0x8015
/* reuse GLX_SCREEN_EXT */
#endif

#ifndef GLX_SGIX_pbuffer
#define GLX_PBUFFER_BIT_SGIX               0x00000004
#define GLX_BUFFER_CLOBBER_MASK_SGIX       0x08000000
#define GLX_FRONT_LEFT_BUFFER_BIT_SGIX     0x00000001
#define GLX_FRONT_RIGHT_BUFFER_BIT_SGIX    0x00000002
#define GLX_BACK_LEFT_BUFFER_BIT_SGIX      0x00000004
#define GLX_BACK_RIGHT_BUFFER_BIT_SGIX     0x00000008
#define GLX_AUX_BUFFERS_BIT_SGIX           0x00000010
#define GLX_DEPTH_BUFFER_BIT_SGIX          0x00000020
#define GLX_STENCIL_BUFFER_BIT_SGIX        0x00000040
#define GLX_ACCUM_BUFFER_BIT_SGIX          0x00000080
#define GLX_SAMPLE_BUFFERS_BIT_SGIX        0x00000100
#define GLX_MAX_PBUFFER_WIDTH_SGIX         0x8016
#define GLX_MAX_PBUFFER_HEIGHT_SGIX        0x8017
#define GLX_MAX_PBUFFER_PIXELS_SGIX        0x8018
#define GLX_OPTIMAL_PBUFFER_WIDTH_SGIX     0x8019
#define GLX_OPTIMAL_PBUFFER_HEIGHT_SGIX    0x801A
#define GLX_PRESERVED_CONTENTS_SGIX        0x801B
#define GLX_LARGEST_PBUFFER_SGIX           0x801C
#define GLX_WIDTH_SGIX                     0x801D
#define GLX_HEIGHT_SGIX                    0x801E
#define GLX_EVENT_MASK_SGIX                0x801F
#define GLX_DAMAGED_SGIX                   0x8020
#define GLX_SAVED_SGIX                     0x8021
#define GLX_WINDOW_SGIX                    0x8022
#define GLX_PBUFFER_SGIX                   0x8023
#endif

#ifndef GLX_SGI_cushion
#endif

#ifndef GLX_SGIX_video_resize
#define GLX_SYNC_FRAME_SGIX                0x00000000
#define GLX_SYNC_SWAP_SGIX                 0x00000001
#endif

#ifndef GLX_SGIX_dmbuffer
#define GLX_DIGITAL_MEDIA_PBUFFER_SGIX     0x8024
#endif

#ifndef GLX_SGIX_swap_group
#endif

#ifndef GLX_SGIX_swap_barrier
#endif

#ifndef GLX_SGIS_blended_overlay
#define GLX_BLENDED_RGBA_SGIS              0x8025
#endif

#ifndef GLX_SGIS_shared_multisample
#define GLX_MULTISAMPLE_SUB_RECT_WIDTH_SGIS 0x8026
#define GLX_MULTISAMPLE_SUB_RECT_HEIGHT_SGIS 0x8027
#endif

#ifndef GLX_SUN_get_transparent_index
#endif

#ifndef GLX_3DFX_multisample
#define GLX_SAMPLE_BUFFERS_3DFX            0x8050
#define GLX_SAMPLES_3DFX                   0x8051
#endif

#ifndef GLX_MESA_copy_sub_buffer
#endif

#ifndef GLX_MESA_pixmap_colormap
#endif

#ifndef GLX_MESA_release_buffers
#endif

#ifndef GLX_MESA_set_3dfx_mode
#define GLX_3DFX_WINDOW_MODE_MESA          0x1
#define GLX_3DFX_FULLSCREEN_MODE_MESA      0x2
#endif

#ifndef GLX_SGIX_visual_select_group
#define GLX_VISUAL_SELECT_GROUP_SGIX       0x8028
#endif

#ifndef GLX_OML_swap_method
#define GLX_SWAP_METHOD_OML                0x8060
#define GLX_SWAP_EXCHANGE_OML              0x8061
#define GLX_SWAP_COPY_OML                  0x8062
#define GLX_SWAP_UNDEFINED_OML             0x8063
#endif

#ifndef GLX_OML_sync_control
#endif

#ifndef GLX_NV_float_buffer
#define GLX_FLOAT_COMPONENTS_NV            0x20B0
#endif

#ifndef GLX_SGIX_hyperpipe
#define GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX 80
#define GLX_BAD_HYPERPIPE_CONFIG_SGIX      91
#define GLX_BAD_HYPERPIPE_SGIX             92
#define GLX_HYPERPIPE_DISPLAY_PIPE_SGIX    0x00000001
#define GLX_HYPERPIPE_RENDER_PIPE_SGIX     0x00000002
#define GLX_PIPE_RECT_SGIX                 0x00000001
#define GLX_PIPE_RECT_LIMITS_SGIX          0x00000002
#define GLX_HYPERPIPE_STEREO_SGIX          0x00000003
#define GLX_HYPERPIPE_PIXEL_AVERAGE_SGIX   0x00000004
#define GLX_HYPERPIPE_ID_SGIX              0x8030
#endif

#ifndef GLX_MESA_agp_offset
#endif


/*************************************************************/

#ifndef GLX_ARB_get_proc_address
//declare *__GLXextFuncPtr();
#typedef __GLXextFuncPtr int;
#endif

#ifndef GLX_SGIX_video_source
#typedef  GLXVideoSourceSGIX XID;
#endif

#ifndef GLX_SGIX_fbconfig
#typedef GLXFBConfigIDSGIX XID;
//typedef struct __GLXFBConfigRec *GLXFBConfigSGIX;
#endif

#ifndef GLX_SGIX_pbuffer
#typedef GLXPbufferSGIX XID;
struct GLXBufferClobberEventSGIX
{
    int type;
    unsigned int serial;	  /* # of last request processed by server */
    Bool send_event;		  /* true if this came for SendEvent request */
    Display *display;		  /* display the event was read from */
    GLXDrawable drawable;	  /* i.d. of Drawable */
    int event_type;		  /* GLX_DAMAGED_SGIX or GLX_SAVED_SGIX */
    int draw_type;		  /* GLX_WINDOW_SGIX or GLX_PBUFFER_SGIX */
    unsigned int mask;	  /* mask indicating which buffers are affected*/
    int x;
	int y;
    int width;
	int height;
    int count;		  /* if nonzero, at least this many more */
} ;
#endif

/* Define int32_t and int64_t types for UST/MSC */
/* (as used in the GLX_OML_sync_control extension). */
//# if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
//# include "inttypes.inc"
//# elif defined( __VMS )
//# include "inttypes.inc"
//# elif defined(__SCO__) || defined(__USLC__)
//# include "stdint.inc"
//# elif defined(__UNIXOS2__) || defined(__SOL64__)
#typedef int32_t int;
#typedef int64_t int64;
//# else
//# include "inttypes.inc"     /* Fallback option */
//# endif

#ifndef GLX_VERSION_1_3
#define GLX_VERSION_1_3 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetFBConfigs (Display *dpy, int screen, int *nelements),GLXFBConfig *;
declare * glXChooseFBConfig (Display *dpy, int screen, int *attrib_list, int *nelements),GLXFBConfig *;
declare * glXGetFBConfigAttrib (Display *dpy, GLXFBConfig config, int attribute, int *value),int;
declare * glXGetVisualFromFBConfig (Display *dpy, GLXFBConfig config),XVisualInfo *;
declare * glXCreateWindow (Display *p, GLXFBConfig c, Window w, int *p),GLXWindow;
declare * glXDestroyWindow (Display *p, GLXWindow w);
declare * glXCreatePixmap (Display *p, GLXFBConfig c, Pixmap p, int *p),GLXPixmap;
declare * glXDestroyPixmap (Display *p, GLXPixmap b);
declare * glXCreatePbuffer (Display *p, GLXFBConfig c, int *p),GLXPbuffer;
declare * glXDestroyPbuffer (Display *p, GLXPbuffer b);
declare * glXQueryDrawable (Display *p, GLXDrawable d, int i, unsigned int *p);
declare * glXCreateNewContext (Display *p, GLXFBConfig c, int i, GLXContext c, Bool b),GLXContext;
declare * glXMakeContextCurrent (Display *p, GLXDrawable d, GLXDrawable d, GLXContext c),Bool;
declare * glXGetCurrentReadDrawable (),GLXDrawable;
declare * glXGetCurrentDisplay (),Display *;
declare * glXQueryContext (Display *p, GLXContext c, int i, int *p),int;
declare * glXSelectEvent (Display *p, GLXDrawable d, unsigned int i);
declare * glXGetSelectedEvent (Display *p, GLXDrawable d, unsigned int *p);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETFBCONFIGSPROC(Display *dpy, int screen, int *nelements),GLXFBConfig *;
//declare *PFNGLXCHOOSEFBCONFIGPROC(Display *dpy, int screen, int *attrib_list, int *nelements),GLXFBConfig *;
//declare *PFNGLXGETFBCONFIGATTRIBPROC(Display *dpy, GLXFBConfig config, int attribute, int *value),int;
//declare *PFNGLXGETVISUALFROMFBCONFIGPROC(Display *dpy, GLXFBConfig config),XVisualInfo *;
//declare *PFNGLXCREATEWINDOWPROC(Display *dpy, GLXFBConfig config, Window win, int *attrib_list),GLXWindow;
//declare *PFNGLXDESTROYWINDOWPROC(Display *dpy, GLXWindow win);
//declare *PFNGLXCREATEPIXMAPPROC(Display *dpy, GLXFBConfig config, Pixmap pixmap, int *attrib_list),GLXPixmap;
//declare *PFNGLXDESTROYPIXMAPPROC(Display *dpy, GLXPixmap pixmap);
//declare *PFNGLXCREATEPBUFFERPROC(Display *dpy, GLXFBConfig config, int *attrib_list),GLXPbuffer;
//declare *PFNGLXDESTROYPBUFFERPROC(Display *dpy, GLXPbuffer pbuf);
//declare *PFNGLXQUERYDRAWABLEPROC(Display *dpy, GLXDrawable draw, int attribute, unsigned int *value);
//declare *PFNGLXCREATENEWCONTEXTPROC(Display *dpy, GLXFBConfig config, int render_type, GLXContext share_list, Bool direct),GLXContext;
//declare *PFNGLXMAKECONTEXTCURRENTPROC(Display *dpy, GLXDrawable draw, GLXDrawable read, GLXContext ctx),Bool;
//declare *PFNGLXGETCURRENTREADDRAWABLEPROC(),GLXDrawable;
//declare *PFNGLXGETCURRENTDISPLAYPROC(),Display *;
//declare *PFNGLXQUERYCONTEXTPROC(Display *dpy, GLXContext ctx, int attribute, int *value),int;
//declare *PFNGLXSELECTEVENTPROC(Display *dpy, GLXDrawable draw, unsigned int event_mask);
//declare *PFNGLXGETSELECTEDEVENTPROC(Display *dpy, GLXDrawable draw, unsigned int *event_mask);
#endif

#ifndef GLX_VERSION_1_4
#define GLX_VERSION_1_4 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetProcAddress (GLubyte *p),__GLXextFuncPtr;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETPROCADDRESSPROC(GLubyte *procName),__GLXextFuncPtr;
#endif

#ifndef GLX_ARB_get_proc_address
#define GLX_ARB_get_proc_address 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetProcAddressARB (GLubyte *p),__GLXextFuncPtr;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETPROCADDRESSARBPROC(GLubyte *procName),__GLXextFuncPtr;
#endif

#ifndef GLX_ARB_multisample
#define GLX_ARB_multisample 1
#endif

#ifndef GLX_ARB_fbconfig_float
#define GLX_ARB_fbconfig_float 1
#endif

#ifndef GLX_SGIS_multisample
#define GLX_SGIS_multisample 1
#endif

#ifndef GLX_EXT_visual_info
#define GLX_EXT_visual_info 1
#endif

#ifndef GLX_SGI_swap_control
#define GLX_SGI_swap_control 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXSwapIntervalSGI (int i),int;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXSWAPINTERVALSGIPROC(int interval),int;
#endif

#ifndef GLX_SGI_video_sync
#define GLX_SGI_video_sync 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetVideoSyncSGI (unsigned int *p),int;
declare * glXWaitVideoSyncSGI (int i, int i, unsigned int *p),int;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETVIDEOSYNCSGIPROC(unsigned int *count),int;
//declare *PFNGLXWAITVIDEOSYNCSGIPROC(int divisor, int remainder, unsigned int *count),int;
#endif

#ifndef GLX_SGI_make_current_read
#define GLX_SGI_make_current_read 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXMakeCurrentReadSGI (Display *p, GLXDrawable d, GLXDrawable d, GLXContext c),Bool;
declare * glXGetCurrentReadDrawableSGI (),GLXDrawable;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXMAKECURRENTREADSGIPROC(Display *dpy, GLXDrawable draw, GLXDrawable read, GLXContext ctx),Bool;
//declare *PFNGLXGETCURRENTREADDRAWABLESGIPROC(),GLXDrawable;
#endif

#ifndef GLX_SGIX_video_source
#define GLX_SGIX_video_source 1
#ifdef __VL_INC__
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXCreateGLXVideoSourceSGIX (Display *p, int i, VLServer s, VLPath p, int i, VLNode n),GLXVideoSourceSGIX;
declare * glXDestroyGLXVideoSourceSGIX (Display *p, GLXVideoSourceSGIX s);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXCREATEGLXVIDEOSOURCESGIXPROC(Display *display, int screen, VLServer server, VLPath path, int nodeClass, VLNode drainNode),GLXVideoSourceSGIX;
//declare *PFNGLXDESTROYGLXVIDEOSOURCESGIXPROC(Display *dpy, GLXVideoSourceSGIX glxvideosource);
#endif /* _VL_H */
#endif

#ifndef GLX_EXT_visual_rating
#define GLX_EXT_visual_rating 1
#endif

#ifndef GLX_EXT_import_context
#define GLX_EXT_import_context 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetCurrentDisplayEXT (),Display *;
declare * glXQueryContextInfoEXT (Display *p, GLXContext c, int i, int *p),int;
declare * glXGetContextIDEXT (GLXContext c),GLXContextID;
declare * glXImportContextEXT (Display *p, GLXContextID c),GLXContext;
declare * glXFreeContextEXT (Display *p, GLXContext c);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETCURRENTDISPLAYEXTPROC(),Display *;
//declare *PFNGLXQUERYCONTEXTINFOEXTPROC(Display *dpy, GLXContext context, int attribute, int *value),int;
//declare *PFNGLXGETCONTEXTIDEXTPROC(GLXContext context),GLXContextID;
//declare *PFNGLXIMPORTCONTEXTEXTPROC(Display *dpy, GLXContextID contextID),GLXContext;
//declare *PFNGLXFREECONTEXTEXTPROC(Display *dpy, GLXContext context);
#endif

#ifndef GLX_SGIX_fbconfig
#define GLX_SGIX_fbconfig 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetFBConfigAttribSGIX (Display *p, GLXFBConfigSGIX c, int i, int *p),int;
declare * glXChooseFBConfigSGIX (Display *p, int i, int *p, int *p),GLXFBConfigSGIX *;
declare * glXCreateGLXPixmapWithConfigSGIX (Display *p, GLXFBConfigSGIX c, Pixmap p),GLXPixmap;
declare * glXCreateContextWithConfigSGIX (Display *p, GLXFBConfigSGIX c, int i, GLXContext c, Bool b),GLXContext;
declare * glXGetVisualFromFBConfigSGIX (Display *p, GLXFBConfigSGIX c),XVisualInfo *;
declare * glXGetFBConfigFromVisualSGIX (Display *p, XVisualInfo *p),GLXFBConfigSGIX;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETFBCONFIGATTRIBSGIXPROC(Display *dpy, GLXFBConfigSGIX config, int attribute, int *value),int;
//declare *PFNGLXCHOOSEFBCONFIGSGIXPROC(Display *dpy, int screen, int *attrib_list, int *nelements),GLXFBConfigSGIX *;
//declare *PFNGLXCREATEGLXPIXMAPWITHCONFIGSGIXPROC(Display *dpy, GLXFBConfigSGIX config, Pixmap pixmap),GLXPixmap;
//declare *PFNGLXCREATECONTEXTWITHCONFIGSGIXPROC(Display *dpy, GLXFBConfigSGIX config, int render_type, GLXContext share_list, Bool direct),GLXContext;
//declare *PFNGLXGETVISUALFROMFBCONFIGSGIXPROC(Display *dpy, GLXFBConfigSGIX config),XVisualInfo *;
//declare *PFNGLXGETFBCONFIGFROMVISUALSGIXPROC(Display *dpy, XVisualInfo *vis),GLXFBConfigSGIX;
#endif

#ifndef GLX_SGIX_pbuffer
#define GLX_SGIX_pbuffer 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXCreateGLXPbufferSGIX (Display *p, GLXFBConfigSGIX c, unsigned int i, unsigned int i, int *p),GLXPbufferSGIX;
declare * glXDestroyGLXPbufferSGIX (Display *p, GLXPbufferSGIX p);
declare * glXQueryGLXPbufferSGIX (Display *p, GLXPbufferSGIX b, int i, unsigned int *p),int;
declare * glXSelectEventSGIX (Display *p, GLXDrawable d, unsigned int i);
declare * glXGetSelectedEventSGIX (Display *p, GLXDrawable d, unsigned int *p);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXCREATEGLXPBUFFERSGIXPROC(Display *dpy, GLXFBConfigSGIX config, unsigned int width, unsigned int height, int *attrib_list),GLXPbufferSGIX;
//declare *PFNGLXDESTROYGLXPBUFFERSGIXPROC(Display *dpy, GLXPbufferSGIX pbuf);
//declare *PFNGLXQUERYGLXPBUFFERSGIXPROC(Display *dpy, GLXPbufferSGIX pbuf, int attribute, unsigned int *value),int;
//declare *PFNGLXSELECTEVENTSGIXPROC(Display *dpy, GLXDrawable drawable, unsigned int mask);
//declare *PFNGLXGETSELECTEDEVENTSGIXPROC(Display *dpy, GLXDrawable drawable, unsigned int *mask);
#endif

#ifndef GLX_SGI_cushion
#define GLX_SGI_cushion 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXCushionSGI (Display *p, Window w, float f);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXCUSHIONSGIPROC(Display *dpy, Window window, float cushion);
#endif

#ifndef GLX_SGIX_video_resize
#define GLX_SGIX_video_resize 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXBindChannelToWindowSGIX (Display *p, int i, int i, Window w),int;
declare * glXChannelRectSGIX (Display *p, int i, int i, int i, int i, int i, int i),int;
declare * glXQueryChannelRectSGIX (Display *p, int i, int i, int *p, int *p, int *p, int *p),int;
declare * glXQueryChannelDeltasSGIX (Display *p, int i, int i, int *p, int *p, int *p, int *p),int;
declare * glXChannelRectSyncSGIX (Display *p, int i, int i, GLenum e),int;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXBINDCHANNELTOWINDOWSGIXPROC(Display *display, int screen, int channel, Window window),int;
//declare *PFNGLXCHANNELRECTSGIXPROC(Display *display, int screen, int channel, int x, int y, int w, int h),int;
//declare *PFNGLXQUERYCHANNELRECTSGIXPROC(Display *display, int screen, int channel, int *dx, int *dy, int *dw, int *dh),int;
//declare *PFNGLXQUERYCHANNELDELTASSGIXPROC(Display *display, int screen, int channel, int *x, int *y, int *w, int *h),int;
//declare *PFNGLXCHANNELRECTSYNCSGIXPROC(Display *display, int screen, int channel, GLenum synctype),int;
#endif

#ifndef GLX_SGIX_dmbuffer
#define GLX_SGIX_dmbuffer 1
#ifdef __DM_BUFFER_INC__
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXAssociateDMPbufferSGIX (Display *p, GLXPbufferSGIX b, DMparams *p, DMbuffer m),Bool;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXASSOCIATEDMPBUFFERSGIXPROC(Display *dpy, GLXPbufferSGIX pbuffer, DMparams *params, DMbuffer dmbuffer),Bool;
#endif /* _DM_BUFFER_H_ */
#endif

#ifndef GLX_SGIX_swap_group
#define GLX_SGIX_swap_group 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXJoinSwapGroupSGIX (Display *p, GLXDrawable d, GLXDrawable d);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXJOINSWAPGROUPSGIXPROC(Display *dpy, GLXDrawable drawable, GLXDrawable member);
#endif

#ifndef GLX_SGIX_swap_barrier
#define GLX_SGIX_swap_barrier 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXBindSwapBarrierSGIX (Display *p, GLXDrawable d, int i);
declare * glXQueryMaxSwapBarriersSGIX (Display *p, int i, int *p),Bool;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXBINDSWAPBARRIERSGIXPROC(Display *dpy, GLXDrawable drawable, int barrier);
//declare *PFNGLXQUERYMAXSWAPBARRIERSSGIXPROC(Display *dpy, int screen, int *max),Bool;
#endif

#ifndef GLX_SUN_get_transparent_index
#define GLX_SUN_get_transparent_index 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetTransparentIndexSUN (Display *p, Window w, Window w, long *p),Status;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETTRANSPARENTINDEXSUNPROC(Display *dpy, Window overlay, Window underlay, long *pTransparentIndex),Status;
#endif

#ifndef GLX_MESA_copy_sub_buffer
#define GLX_MESA_copy_sub_buffer 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXCopySubBufferMESA (Display *p, GLXDrawable d, int i, int i, int i, int i);
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXCOPYSUBBUFFERMESAPROC(Display *dpy, GLXDrawable drawable, int x, int y, int width, int height);
#endif

#ifndef GLX_MESA_pixmap_colormap
#define GLX_MESA_pixmap_colormap 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXCreateGLXPixmapMESA (Display *p, XVisualInfo *p, Pixmap p, Colormap m),GLXPixmap;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXCREATEGLXPIXMAPMESAPROC(Display *dpy, XVisualInfo *visual, Pixmap pixmap, Colormap cmap),GLXPixmap;
#endif

#ifndef GLX_MESA_release_buffers
#define GLX_MESA_release_buffers 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXReleaseBuffersMESA (Display *p, GLXDrawable d),Bool;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXRELEASEBUFFERSMESAPROC(Display *dpy, GLXDrawable drawable),Bool;
#endif

#ifndef GLX_MESA_set_3dfx_mode
#define GLX_MESA_set_3dfx_mode 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXSet3DfxModeMESA (int i),Bool;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXSET3DFXMODEMESAPROC(int mode),Bool;
#endif

#ifndef GLX_SGIX_visual_select_group
#define GLX_SGIX_visual_select_group 1
#endif

#ifndef GLX_OML_swap_method
#define GLX_OML_swap_method 1
#endif

#ifndef GLX_OML_sync_control
#define GLX_OML_sync_control 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetSyncValuesOML (Display *p, GLXDrawable d, int64_t *p, int64_t *p, int64_t *p),Bool;
declare * glXGetMscRateOML (Display *p, GLXDrawable d, int32_t *p, int32_t *p),Bool;
declare * glXSwapBuffersMscOML (Display *p, GLXDrawable d, int64_t i, int64_t i, int64_t i),int64_t;
declare * glXWaitForMscOML (Display *p, GLXDrawable d, int64_t i, int64_t i, int64_t i, int64_t *p, int64_t *p, int64_t *p),Bool;
declare * glXWaitForSbcOML (Display *p, GLXDrawable d, int64_t i, int64_t *p, int64_t *p, int64_t *p),Bool;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETSYNCVALUESOMLPROC(Display *dpy, GLXDrawable drawable, int64_t *ust, int64_t *msc, int64_t *sbc),Bool;
//declare *PFNGLXGETMSCRATEOMLPROC(Display *dpy, GLXDrawable drawable, int32_t *numerator, int32_t *denominator),Bool;
//declare *PFNGLXSWAPBUFFERSMSCOMLPROC(Display *dpy, GLXDrawable drawable, int64_t target_msc, int64_t divisor, int64_t remainder),int64_t;
//declare *PFNGLXWAITFORMSCOMLPROC(Display *dpy, GLXDrawable drawable, int64_t target_msc, int64_t divisor, int64_t remainder, int64_t *ust, int64_t *msc, int64_t *sbc),Bool;
//declare *PFNGLXWAITFORSBCOMLPROC(Display *dpy, GLXDrawable drawable, int64_t target_sbc, int64_t *ust, int64_t *msc, int64_t *sbc),Bool;
#endif

#ifndef GLX_NV_float_buffer
#define GLX_NV_float_buffer 1
#endif

#ifndef GLX_SGIX_hyperpipe
#define GLX_SGIX_hyperpipe 1

struct GLXHyperpipeNetworkSGIX {
    dstring pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int     networkId;
} ;

struct GLXHyperpipeConfigSGIX {
    dstring pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int     channel;
    unsigned int participationType;
    int     timeSlice;
} ;

struct GLXPipeRect {
    dstring pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int srcXOrigin;int srcYOrigin;int srcWidth;int srcHeight;
    int destXOrigin;int destYOrigin;int destWidth;int destHeight;
} ;

struct GLXPipeRectLimits {
    dstring pipeName[GLX_HYPERPIPE_PIPE_NAME_LENGTH_SGIX];
    int XOrigin;int YOrigin;int maxHeight;int maxWidth;
} ;

#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXQueryHyperpipeNetworkSGIX (Display *p, int *p),GLXHyperpipeNetworkSGIX *;
declare * glXHyperpipeConfigSGIX (Display *p, int i, int i, GLXHyperpipeConfigSGIX *p, int *p),int;
declare * glXQueryHyperpipeConfigSGIX (Display *p, int i, int *p),GLXHyperpipeConfigSGIX *;
declare * glXDestroyHyperpipeConfigSGIX (Display *p, int i),int;
declare * glXBindHyperpipeSGIX (Display *p, int i),int;
declare * glXQueryHyperpipeBestAttribSGIX (Display *p, int i, int i, int i, void *p, void *p),int;
declare * glXHyperpipeAttribSGIX (Display *p, int i, int i, int i, void *p),int;
declare * glXQueryHyperpipeAttribSGIX (Display *p, int i, int i, int i, void *p),int;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXQUERYHYPERPIPENETWORKSGIXPROC(Display *dpy, int *npipes),GLXHyperpipeNetworkSGIX *;
//declare *PFNGLXHYPERPIPECONFIGSGIXPROC(Display *dpy, int networkId, int npipes, GLXHyperpipeConfigSGIX *cfg, int *hpId),int;
//declare *PFNGLXQUERYHYPERPIPECONFIGSGIXPROC(Display *dpy, int hpId, int *npipes),GLXHyperpipeConfigSGIX *;
//declare *PFNGLXDESTROYHYPERPIPECONFIGSGIXPROC(Display *dpy, int hpId),int;
//declare *PFNGLXBINDHYPERPIPESGIXPROC(Display *dpy, int hpId),int;
//declare *PFNGLXQUERYHYPERPIPEBESTATTRIBSGIXPROC(Display *dpy, int timeSlice, int attrib, int size, void *attribList, void *returnAttribList),int;
//declare *PFNGLXHYPERPIPEATTRIBSGIXPROC(Display *dpy, int timeSlice, int attrib, int size, void *attribList),int;
//declare *PFNGLXQUERYHYPERPIPEATTRIBSGIXPROC(Display *dpy, int timeSlice, int attrib, int size, void *returnAttribList),int;
#endif

#ifndef GLX_MESA_agp_offset
#define GLX_MESA_agp_offset 1
#ifdef GLX_GLXEXT_PROTOTYPES
declare * glXGetAGPOffsetMESA (void *p),unsigned int;
#endif /* GLX_GLXEXT_PROTOTYPES */
//declare *PFNGLXGETAGPOFFSETMESAPROC(void *ptr),unsigned int;
#endif


#ifdef __cplusplus
}
#endif

#endif
